//
//  BTDataProcessVC.h
//  Unity-iPhone
//
//  Created by leon on 2021/2/3.
//

#import <UIKit/UIKit.h>
#import "MYFactoryManager.h"
#import "LEONBLManager.h"

//游戏类型
typedef NS_ENUM(int, GAME_TYPE){
    GAME_TYPE_DEMO =0, //
    GAME_TYPE_RUN, //
    GAME_TYPE_DANCE, //
    GAME_TYPE_SDAER, //
};

//蓝牙状态
typedef NS_ENUM(NSInteger, BLETOOTH_STUTAS){
    CONNECT_DIS =0, // 未链接
    CONNECT_ING , //链接中
    CONNECT_ED,// 已链接
    CONNECT_LOST, // 丢失链接 /链接失败
};

@interface BTDataProcess : UIViewController
    
//趣动跳转过来携带的mac 实际是蓝牙设备的identity
@property(copy,nonatomic)NSString * macAddress;
//弹窗 unity主动选择链接 主0 副1 设备
@property(assign,nonatomic)DEVICE_TYPE deviceType;
//游戏种类 1是跳舞 3是跑酷 2是赛达尔传说 4是demo->dance
@property(assign,nonatomic)GAME_TYPE game_type;

//蓝牙设备数据源回调给popSeaechView
@property(copy,nonatomic)void (^deviceArrBLock)(NSMutableArray*arr);
//脚步交互数据
@property(copy,nonatomic)void (^getInteractionBlock)(int interaction);

//程序在前台还是后台
@property(assign,nonatomic)int isBackGround;

//单例->初始化蓝牙
+(instancetype)sharedInstance;

//初始化中心管理
-(void)initCBCentralManager;
//app跳转直接连 或 tableview 选中
-(void)connectPeripheral:(CBPeripheral*)peripheral;
//unity或者趣动请求 外部断开蓝牙链接
-(void)disConnedctBle;


//监听通知开始游戏
-(void)gameStartInitData;
//监听通知结束游戏
-(void)gameEndInitData;
//监听通知震动
-(void)vibrationAction:(int)type duration:(int)duration;

@end



